*	FRACTF.FOR -> FRACTF.EXE, FORTRAN module for FRACT.BAS       McCopies & D.Stribute 2001/03
*	for the IBM Professional FORTRAN Compiler (V1.00)

**	remember :

*     only SINGLE quotes, no "
*     no  OPEN(TYPE=
*	doesnt seem to work:	ACCESS='APPEND'
*     lowercase seem oK
*	INCLUDE 'FRINCL.F'  does seem to work
*	add.4+4bytes with unformatted output ???XXXXX    4B/2B/4B    GRRRRRRR   2/10   S/N
*     V1.06 unformatted output of (VAL(I),I=1,NV),NV=16 ==>  4B/NV*2B/4B   ?        32/40
*     V1.07 unformatted output of (VAL(I),I=1,NV),NV=32 ==>  4B/NV*2B/4B   ?        64/72


	PROGRAM	FRACTF

	REAL*4	MINR,MAXR
	INTEGER*2	K

	REAL*4	ZSTEPS
	DIMENSION	ZSTEPS(128)
	COMMON	NST,ZSTEPS

	INTEGER*2	VAL,CNT
	DIMENSION	VAL(32)
	NV=32

*	--- read input from file FRACTF.INP: ---

	OPEN(10,FILE='FRACTF.INP',ACCESS='READ',ERR=90)

	WRITE(6,*) 'FRACTF.EXE V1.07:  reading FRACTF.INP ...'

	READ(10,201) NX
	READ(10,201) NY
	WRITE(6,*) 'NX,NY=',NX,NY

	NXY=NX*NY
	IF((NXY-INT(NXY/NV)*NV).NE.0) STOP 'nx*ny mod nv >0 !!!???'

	READ(10,201) MAX
	WRITE(6,*) 'MAX=',MAX


	READ(10,200) RMAX
	WRITE(6,*) 'RMAX=',RMAX

	READ(10,205) XMIN
	READ(10,*) XMAX
	READ(10,*) YMIN
	READ(10,205) YMAX
	WRITE(6,*) 'XMIN/MAX=', XMIN,XMAX
	WRITE(6,*) 'YMIN/MAX=', YMIN,YMAX

	READ(10,201) NST
	WRITE(6,*) 'NST=',NST

205	FORMAT(F20.10)
201	FORMAT(I10)
200	FORMAT(F18.9)
	CLOSE(10)


*	--- read ZSTEPS from file FRACT.DAT: ---

	CALL	RDSTEPS

	WRITE(6,*) 'FRACTF.EXE is writing to FRACTF.BIN ...'

	nx1=NX-1
	ny1=NY-1
	dx = (xmax - xmin) / nx1
	dy = (ymax - ymin) / ny1

	MAXR=0
	MINR=RMAX
	MIN=MAX
	K2MIN=0
	K2MAX=-30000
	
	
	OPEN(11,FILE='FRACTF.BIN',FORM='UNFORMATTED',ERR=91,
     +ACCESS='WRITE')

* ------- cycle for all points, writing data to FRACTF.BIN:  -------------------

	CNT=0
	DO 3 IY=0,ny1

	Y0=YMIN+IY*DY

	DO 2 IX=0,nx1

	Y=Y0
	X=XMIN+IX*DX	

*	MANDELBROT:
	X00=X
	Y00=Y

*	JULIA
*	x00=0.5
*	y00=0.3

* --- cycle K=RECHENTIEFE: ---

	DO 1 K=1,MAX

	X2=X*X
	Y2=Y*Y

*	complex zn = z^2 + z0	

	y = 2 * x * y + y00
	x = x2 - y2 + x00 
	r = x2 + y2

	IF(R.GT.RMAX) GOTO 20

1	CONTINUE

	IF(R.GT.MAXR) MAXR=R
	IF(R.LT.MINR) MINR=R

* --- convert r to k2: ---  k2 = -1 .. -nst

	DO 15 K2 = 1,(NST-1)
	IF(R.GT.ZSTEPS(K2)) GOTO 16
15	CONTINUE
	K2=NST
16	CONTINUE	
	K2=-K2
	IF(K2.GT.K2MAX) K2MAX=K2
	IF(K2.LT.K2MIN) K2MIN=K2
	K=K2

20	CONTINUE

	CNT=CNT+1
	VAL(CNT)=K
	IF(CNT.GE.NV) THEN
	WRITE(11) (VAL(I),I=1,NV)
	CNT=0
	ENDIF

*	write(6,*) 'x,y,k=',x00,y00,k

2	CONTINUE
3	CONTINUE

	CLOSE(11)

	WRITE(6,*) 'MINR,MAXR=',MINR,MAXR

	WRITE(6,*) '  have a nice day, week, and year !!!'

	STOP ' s h u n d a h a i  '
90	STOP 'error opening infile fractf.inp'
91	STOP 'error opening outfile fractf.bin'
	
	END

* -------------------------------------------------------------------------------

	SUBROUTINE RDSTEPS

	REAL*4	ZSTEPS
	DIMENSION	ZSTEPS(128)
	COMMON	NST,ZSTEPS

	WRITE(6,*) 'readsteps.........NST=',NST

	OPEN(12,FILE='FRACT.DAT',ACCESS='READ',ERR=1299)

	DO 100 I=1,NST
	READ(12,1200) ZSTEPS(I)

*	write(6,*) i,zsteps(i)

100	CONTINUE

	CLOSE(12)
	RETURN

1200	FORMAT(F20.10)

1299	STOP 'error opening infile FRACT.DAT'
	END