'  PIC.bas   read &display FRACT.BIN                McCopies &.D.Stribute 2001
'            write FRACT.BMP as trueColor
'  his       read 16col-palette from *.PCX or *.COL
'    to      [color mix by points of alternating color
'     ry     [pal32& with mixed colors
'            second palette pals2 for 'inside' colors
'            pals64, pals99
'            count outside colors/steps from 0, not from min !
'  24.02.    scale-DOWN-factor for previewing larger images:  zscd

' #1  read color palette from ..\PCX-file
' #2  read image data from FRACT.BIN
' #3  read color palette from ..\COL-file
' #4  write FRACT.BMP (true color)
' #5  read color palette from ..\MAP-file
' #6


DEFINT I-N, X-Z

DECLARE SUB cyclecol (dir AS INTEGER) ' cycle palette pal&(0..31)
DECLARE SUB cyclepal ()   ' cycle colors
DECLARE SUB inipal ()     ' ini pal& with DOS default values
DECLARE SUB inipal1 ()    ' ini pal& with shades of grey
DECLARE SUB readPCXpal (file$, ishift) ' read color palette from (F3D).PCX -> pal&
DECLARE SUB readPCXpal2 (file$, ishift) ' read color palette from (F3D).PCX -> pals2
DECLARE SUB readCOL (file$, ishift)    ' read color palette from (F3D).COL -> pal&
DECLARE SUB readCOL2 (file$, ishift)   ' read color palette from (F3D).COL -> pals2
DECLARE SUB waitkb ()     ' wait for keystroke
DECLARE SUB copypal ()    ' supply pal&(16..31) + pals(0..15)
DECLARE SUB openBMP4 (w%, h%)   ' open BMP outfile as #4 and write header
DECLARE SUB conv63 (x%)
DECLARE SUB readmap16 (file$, shift%)     ' read *.MAP file 16 cols
DECLARE SUB readMAP99 (file$, shift%)     ' read *.MAP file n(16-300) cols
DECLARE SUB inipals64 (shift%)    ' 64 shades of grey

DECLARE FUNCTION capit$ (xx AS STRING)   ' capitalize xx
DECLARE FUNCTION rgb& (r%, g%, b%)       ' 3*0..63 RGB as long&
DECLARE FUNCTION byte4$ (z&)             ' string*4 from long integer

DECLARE SUB debug1 ()
DECLARE SUB debug2 ()
DECLARE SUB errmsg (msg$)       ' print msg and stop

DIM SHARED pal&(0 TO 31)                 ' 3x(0..63)    1x0
DIM SHARED pals(0 TO 15) AS STRING * 3   ' 3x(0..255) 16 colors
DIM SHARED pals2(0 TO 15) AS STRING * 3  ' 3x(0..255) 16 colors
DIM SHARED pal32(0 TO 31) AS STRING * 3  ' 3x(0..255) 32 colors
DIM SHARED pals99(0 TO 300) AS STRING * 3  ' 3x(0..255) n colors
DIM SHARED n99          ' number of colors read by readMAP99 from *.MAP
DIM SHARED pals64(0 TO 63) AS STRING * 3
DIM SHARED kwait AS LONG
DIM SHARED kwrite AS INTEGER
DIM SHARED idir AS INTEGER
DIM SHARED d0$: DIM SHARED dir$

DIM kb AS LONG
DIM kf AS SINGLE
DIM w AS INTEGER: DIM h AS INTEGER
DIM zsc AS SINGLE    ' scale factor

DIM SHARED nst AS INTEGER
'nst = 16
nst = 64
DIM SHARED zcount(0 TO nst) AS LONG

' --- definiere tasten fr "Ereignisverfolgung"             : ---

ON KEY(11) GOSUB up: ON KEY(14) GOSUB down       ' speed up/down  UP DO
ON KEY(3) GOSUB up: ON KEY(4) GOSUB down         ' speed up/down  F3 F4
ON KEY(12) GOSUB key12: ON KEY(13) GOSUB key13   ' shiftl palette LE RI
ON KEY(5) GOSUB key12: ON KEY(6) GOSUB key13     ' shiftr palette F5 F6
ON KEY(1) GOSUB key1    ' toggle direction of color cycling           F1
ON KEY(2) GOSUB key2    ' readPCXcol               read col from PCX  F2
ON KEY(7) GOSUB key7    ' read *.col file          read col from COL  F7
ON KEY(10) GOSUB key10  ' read+write again                restart     F10

KEY(0) ON
SCREEN 12          ' screen mode 12: grafics 640x480 pixel 16 colors
'inipal            ' initialize pal& and pals with DOS deafult colors

                   ' ** <<<<<<<< set directories
d0$ = "d:\": dir$ = "c:\win16\f3d\"         ' ch's ME/900
d0$ = "c:\": dir$ = "c:\spiele\frac3d\"     ' sb's toshiba notebook
'd0$ = "d:\": dir$ = "d:\f3d\"               ' wa's 486

'readcol "",0   'ask
'readPCXpal "apf1", 15
'readCOL2 "grau1", 2
'readCOL2 "rb0", 1
'readCOL2 "rb1", 15

'readCOL2 "rs1", 1: readPCXpal "wirbel", 14   ' -> APF640a
'readCOL2 "rs0", 1: readPCXpal "wirbel", 13   ' -> APF640b
'readCOL2 "rs1", 2: readPCXpal "wirbel", 12   ' -> APF640c
'readCOL2 "rs0", 2: readPCXpal "wirbel", 11   ' -> APF640d

'readCOL2 "rsc1", 1: readPCXpal "wirbel", 10   ' -> APF640e
'readCOL2 "rsc0", 1: readPCXpal "wirbel", 9    ' -> APF640f
'readCOL2 "rsc1", 2: readPCXpal "wirbel", 8    ' -> APF640g
'readCOL2 "rsc0", 2: readPCXpal "wirbel", 7    ' -> APF640h

'readCOL2 "rbb1", 1: readPCXpal "wirbel", 6    ' -> APF640i
'readCOL2 "rbb0", 1: readPCXpal "wirbel", 5    ' -> APF640j
'readCOL2 "rbb1", 2: readPCXpal "wirbel", 4    ' -> APF640k
'readCOL2 "rbb0", 2: readPCXpal "wirbel", 3    ' -> APF640l

'readCOL2 "wirbel0", 2: readPCXpal "wirbel", 2     ' -> ..M
'readCOL2 "wirbel1", 2: readPCXpal "wirbel", 1     ' -> ..N
'readCOL2 "wirbel0", 10: readPCXpal "wirbel", 0    ' -> 1..O
'readCOL2 "wirbel1", 10: readPCXpal "wirbel", 15   ' -> 2
'readCOL2 "wirbel1", 15: readPCXpal "wirbel", 15   ' -> 3
'readCOL2 "wirbel1", 4: readPCXpal "wirbel", 15     ' -> 4..P
                                
'readCOL2 "grau1", 0: readPCXpal "wirbel", 0     ' -> wirbel  10
'readCOL2 "grau1", 5: readPCXpal "wirbel", 2     ' -> wirbel  11
'readCOL2 "grau1", 11: readPCXpal "wirbel", 6    ' -> wirbel  12
'readCOL2 "grau1", 8: readPCXpal "wirbel", 10     ' -> wirbel  13

'readCOL2 "grau1", 7: readPCXpal "wirbel", 14    ' -> wirbel16  640*480
'readCOL2 "grau0", 7: readMAP16 "test2", 0       ' -> wirbel17xxxx
'readCOL2 "grau0", 7: readMAP16 "HUES", 0        ' -> wirbel18
'readCOL2 "grau1", 7: readMAP16 "HUES", -1       ' -> wirbel19 screen=..20

'readCOL2 "grau1", 7: readMAP99 "HUES32", 0       ' -> wirbel30
'readCOL2 "grau1", 0: readMAP99 "HUES32", -1      ' -> wirbel31
'readCOL2 "grau0", 6: readMAP99 "HUES32", -16     ' -> wirbel32
'readCOL2 "grau0", 14: readMAP99 "HUES32", -8      ' -> wirbel33
'readCOL2 "grau0", 10: readMAP99 "HUES32", -24      ' -> wirbel34

' using 64*grey palette pals64:
'inipals64 0: readMAP99 "HUES32", -24      ' -> wirbel35
'inipals64 -32: readMAP99 "HUES32", 24      ' -> wirbel36
'inipals64 -25: readMAP99 "HUES32", 16      ' -> wirbel37
'inipals64 25: readMAP99 "HUES32", 8      ' -> wirbel38

'readPCXpal "apf1", 0
'inipal
'readCOL2 "wirbel", 0
zscd = 1      ' scale down factor
'inipals64 25: readMAP99 "HUES32", 8      ' -> wirb2x1  // 0 instead min:
                           ' min=100  100MOD64=36  36+8=44
'inipals64 24: readMAP99 "HUES32", 44: zscd = 8     ' WIRB2y1  2/8=160*120
'inipals64 26: readMAP99 "HUES32", 48: zscd = 8     ' WIRB2y2  2/8=160*120
'inipals64 25: readMAP99 "HUES32", 48: zscd = 1     ' WIRB2x38 == WI..38
'inipals64 26: readMAP99 "HUES32", 48: zscd = 1     ' WIRB2x39
'inipals64 27: readMAP99 "HUES32", 50: zscd = 1     ' WIRB2x40
'inipals64 28: readMAP99 "HUES32", 52: zscd = 1     ' WIRB2x41

'inipals64 25: readMAP99 "HUES40", 52: zscd = 4     ' WIRB2y3 ??
'inipals64 0: readMAP99 "HUES42", 52: zscd = 4     ' WIRB2y4  !???
' ..... r/b switched in readMAP99 ...
'inipals64 0: readMAP99 "HUES42", 0: zscd = 4       ' WIRB2y5  !??
'inipals64 10: readMAP99 "HUES37", 0: zscd = 4      ' WIRB2y6
'inipals64 42: readMAP99 "HUES64", 0: zscd = 4      ' WIRB2y7
'inipals64 25: readMAP99 "HUES64", 10: zscd = 4     ' WIRB2y8
'inipals64 26: readMAP99 "HUES64", 8: zscd = 4      ' WIRB2y9
'inipals64 25: readMAP99 "HUES62", 12: zscd = 4     ' WIRB2ya
'inipals64 26: readMAP99 "HUES60", 16: zscd = 4     ' WIRB2yb
'inipals64 25: readMAP99 "HUES55", 26: zscd = 4     ' WIRB2yc
'inipals64 26: readMAP99 "HUES64", 8: zscd = 1      ' WIRB2x42 == WIRB2y9

'inipals64 25: readmap99 "HUES32", 12: zscd = 1   ' WiZoo1.b...WiZoo10.g
'inipals64 45: readmap99 "HUES32", 4: zscd = 2   ' WiZoo11.b
'inipals64 35: readmap99 "HUES32", 8: zscd = 2   ' WiZoo12.b
'inipals64 33: readmap99 "HUES32", 2: zscd = 2   ' WiZoo13.b
'inipals64 32: readmap99 "HUES32", 24: zscd = 1   ' WiZoo21
'inipals64 32: readmap16 "HUES", 8: zscd = 1  ' WiZoo22

'inipals64 32: readmap16 "HUES", 8: zscd = 1  ' Wirb50
n99 = 16
'inipals64 25: readMAP99 "HUES32", 8      ' -> wirb52
inipals64 25: readMAP99 "HUES32", -8      ' -> wirb53



                                
                                 ' *** <<<<<< define colors
                               

restart:           ' ---------------------------------------------
'CLS                ' clear screen

FOR i = 0 TO kz: zcount(i) = 0: NEXT i ' init counter with 0

kwrite = 1    ' kwrite>0 .. write BMP-file
kb = 0        ' counter for bytes written to BMP file
kf = 1.4      ' factor for kwait
kwait = 100   ' initialise verzgerungsfaktor

ll = 30       ' last line for PRINT  (NO INPUT!)

f$ = d0$ + "fract.bin"
OPEN f$ FOR BINARY AS #2

GET #2, 33, w
GET #2, 35, h
GET #2, 37, min
GET #2, 39, max
GET #2, 41, k2min
GET #2, 43, k2max
GET #2, 45, nsteps
GET #2, 47, k1111       ' flag for mirror symmetry
'k1111 = 1111     ' read old file !!

LOCATE 1, 1
PRINT "w,h= ", w, h
IF zscd > 1 THEN     ' ------- scale DOWN to make preViewImage
IF w MOD zscd > 0 OR h MOD zscd > 0 THEN errmsg " odd scaling-Down ratio !!"
w = w / zscd: h = h / zscd
PRINT "scaled down to: ", w, h
END IF
PRINT "min,max=", min, max
PRINT "k2min,k2max=", k2min, k2max
PRINT nsteps, " nsteps"
IF nsteps <> nst THEN errmsg " nsteps <> nst !!! "
IF k1111 = 1111 THEN PRINT "mirror symmetrical file!"

'  debug1

IF kwrite > 0 THEN
   openBMP4 w, h
   LOCATE ll, 1: PRINT "writing FRACT.BMP...";
END IF


white$ = CHR$(255) + CHR$(255) + CHR$(255)
black$ = CHR$(0) + CHR$(0) + CHR$(0)

xc& = 129             ' initialize read counter

xx = 640: yy = 480    ' output screen size
xr = (xx - w) / 2     ' margins
yr = (yy - h) / 2

IF w <= 640 THEN
zsc = 1
ELSE
zsc = (1! * xx) / w   ' calc. scale factor for screen display
END IF


ya0 = (480 / zsc) * 2.2 / 2.4       ' --- calc. axis
ya1 = (480 / zsc - 1) * 1.2 / 2.4
ya2 = ya1 + 1
ya3 = (480 / zsc) * .2 / 2.4

xa2 = (640 / zsc) * .5 / 3.2
xa1 = (640 / zsc) * 1.5 / 3.2
xa4 = (8 * xa1 + 2 * xa2) / 10    ' limit for 00xxx axis   -1.2
xa5 = xa2 - (xa1 - xa2) / 10      ' -2.1
xa0 = (640 / zsc - 1) * 2.5 / 3.2
xa3 = xa0 + 1                      ' --- axis



' =============== cycle for all points : ==================

FOR y = 1 TO h          ' cycle for all lines of image
FOR x = 1 TO w          ' cycle for all pixels in line

GET #2, xc&, z       ' read 1 word for 1 pixel from FRACT.BIN
xc& = xc& + 2 * zscd ' advance read counter

IF z > 0 THEN     ' "OUTSIDE"

zcol = z MOD 16       '  color   0..15
zpcol = z MOD n99     ' print color   0..n99-1

ELSE     ' z<0    '  "INSIDE"  "lake"
az = -z
IF az < 0 OR az > nst THEN errmsg "unexpected AZ value"
zcount(az) = zcount(az) + 1
z2col = az - 1 ' print col
az = az MOD 16
zcol = az    ' screen col
END IF   ' z




IF zsc < 1 THEN
PSET (x * zsc, y * zsc), zcol
ELSE
PSET (x, y), zcol
END IF


IF kwrite > 0 THEN    ' ++++++++++++++++++++++++++++++++++++++++++++++++++++

IF z > 0 THEN
'PRINT #4, pal32(zpcol);   ' use 32 color palette
'PRINT #4, pals(zcol);   ' use 16 color palette
PRINT #4, pals99(zpcol);   ' use n99 color palette
'PRINT #4, white$;     ' b/w
ELSE
'PRINT #4, pals2(z2col);   ' inside color from palette 2
PRINT #4, pals64(z2col);   ' inside color from palette64
'PRINT #4, black$;           ' b/w
END IF

kb = kb + 3
END IF            ' ++++++++++++++++++++++++++++++++++++++++++++++++++++

NEXT x       ' next pixel in line

IF zscd > 1 THEN    ' scaling DOWN -> skip input line(s) !
                    ' 1 line = 2*w*zscd bytes
                    ' skip (zscd-1) lines:
xc& = xc& + (zscd - 1) * 2 * w * zscd   ' advance read counter

END IF


IF k1111 = 1111 THEN                  ' symmetrical image. read file twice !
IF zscd > 1 THEN errmsg " not implemented"
IF y = h / 2 THEN xc& = xc& - 2 * w   ' read same line again
IF y > h / 2 THEN xc& = xc& - 4 * w   ' read previous line (again)
END IF

NEXT y            ' ===== next line =====


CLOSE #1
CLOSE #4
LOCATE ll, 1: PRINT "done. files closed.      ";

'debug2    ' printout steps

BEEP: BEEP
SYSTEM
waitkb
cyclepal    ' exit with ESC-> restart
CLOSE

waitkb
GOTO restart


SYSTEM      'return to DOS if started from DOS
' end main ===================================


down:
IF kwait < 2000000000 THEN
kwait = kwait * kf
IF kwait = 0 THEN kwait = 1
ELSE
BEEP
END IF
GOSUB prt1
RETURN

up:
IF kwait > 0 THEN
kwait = kwait / kf
ELSE
BEEP
END IF
GOSUB prt1
RETURN

prt1:
LOCATE ll, 1: PRINT "kwait="; kwait; "   ";
RETURN

key1:
idir = -idir
RETURN

key12:
cyclecol 0
RETURN
key13:
cyclecol 1
RETURN

key2:
readPCXpal "", 0
RETURN

key10:
CLOSE
GOTO restart
RETURN

key7:
readCOL "", 0
RETURN

DEFSNG I-N, X-Z
FUNCTION byte4$ (z&)    ' convert long integer to 4 byte string

zz& = z&
b$ = ""

FOR i = 1 TO 4
k% = zz& MOD 256
b$ = b$ + CHR$(k%)
zz& = INT(zz& / 256)
NEXT i

byte4$ = b$

END FUNCTION

DEFINT I-N, X-Z
FUNCTION capit$ (xx AS STRING) ' capitalized string: [a-z] -> [A-Z]
x$ = xx
FOR i = 1 TO LEN(x$)

c$ = MID$(x$, i, 1)
IF c$ >= "a" AND c$ <= "z" THEN
  MID$(x$, i, 1) = CHR$(ASC(c$) - 32) ' capitalize
END IF
IF c$ = "" THEN MID$(x$, i, 1) = ""
IF c$ = "" THEN MID$(x$, i, 1) = ""
IF c$ = "" THEN MID$(x$, i, 1) = ""

NEXT i
capit$ = x$

END FUNCTION

DEFINT A-H, O-W
SUB conv63 (x%)

' x=0..100  -->  0..63

x% = INT(x% * 64 / 100)
IF x% > 63 THEN x% = 63

END SUB

DEFSNG A-W
SUB copypal      ' 1) supply pal&(16..31) = pal&(0..15)
                 ' 2) supply pals(0..15)
                 ' 3) supply pal32(0..31)


'IF kwrite = 0 THEN            ' no BMP output: only 1) needed
FOR i = 0 TO 15               ' 1)
pal&(16 + i) = pal&(i)
NEXT i

'??? ELSE
p& = pal&(15)
x = p& MOD 256    ' R(15)-value  0..63
r0 = x * 4        ' R(15)-value  0..255
p& = p& / 256
x = p& MOD 256      ' G(15)-value  0..63
g0 = x * 4          ' G(15)-value  0..255
p& = p& / 256
x = p& MOD 256      ' B(15)-value  0..63
b0 = x * 4          ' B(15)-value  0..255


FOR i = 0 TO 15
p& = pal&(i)
pal&(16 + i) = p&                       ' 1)

x = p& MOD 256   ' R-value  0..63
r = x * 4        ' R-value  0..255
s1$ = CHR$(r)     ' s$ = first byte
p& = p& / 256

x = p& MOD 256      ' G-value  0..63
g = x * 4           ' G-value  0..255
s2$ = CHR$(g)
p& = p& / 256

x = p& MOD 256      ' B-value  0..63
b = x * 4           ' B-value  0..255
s3$ = CHR$(b)       ' 3rd byte

s$ = s3$ + s2$ + s1$

pals(i) = s$        ' pals(i) = three-byte-colorvalue RGB    2)

pal32(i * 2) = s$      ' pal32 (0/2/4..30) = 16 original colors

                               ' i=0..15
i1 = i * 2 - 1                 ' i1= 31/1/3..29
IF i1 < 0 THEN i1 = 31

' -- make "new" intermediate colors: --

' - arithmetisches mittel: -

r = (r + r0) / 2
g = (g + g0) / 2
b = (b + b0) / 2

s$ = CHR$(b) + CHR$(g) + CHR$(r)

pal32(i1) = s$


NEXT i

'??? END IF

END SUB

SUB cyclecol (dir AS INTEGER)      ' cycle color palette in PAL&
                                   ' in given DIRection

IF dir MOD 2 = 0 THEN       ' copy "down"
FOR i = 0 TO 15
pal&(i) = pal&(i + 1)
NEXT i

ELSE                        ' copy "up"
FOR i = 15 TO 1 STEP -1
pal&(i) = pal&(i - 1)
NEXT i
pal&(0) = pal&(31)

END IF

copypal
PALETTE USING pal&

END SUB

DEFINT I-N
SUB cyclepal   ' cycle color palette pal&

DIM PAL1&(0 TO 15)

ii = 0      ' cycle 16
'ii = 1      ' cycle 15

idir = 1           ' direction = +/- i

k = 0
kmax = 16 - ii

nextk:

IF ii > 0 THEN PAL1&(0) = pal&(0)   ' reset outside to color0

FOR i = ii TO 15    ' 16-ii colors

PAL1&(i) = pal&(i + k)

NEXT i

PALETTE USING PAL1&

FOR j& = 1 TO kwait: NEXT j&  ' warteSchleife

k = k + idir
IF k < 0 THEN k = kmax
IF k > kmax THEN k = 0

IF INKEY$ <> CHR$(27) GOTO nextk

END SUB

SUB debug1

LOCATE 5, 1

PRINT
FOR i = 0 TO 15
PRINT USING "##"; i;
x$ = pals(i)
PRINT x$; ASC(MID$(x$, 1, 1)); ASC(MID$(x$, 2, 1)); ASC(MID$(x$, 3, 1))
NEXT i


END SUB

SUB debug2

LOCATE 1, 1
FOR i = 1 TO nst
PRINT i; zcount(i)
NEXT i

END SUB

SUB errmsg (msg$)
BEEP: BEEP
LOCATE 5, 1
PRINT " @@@ ERROR !!!    "; msg$
PRINT
BEEP: BEEP
SYSTEM
END SUB

DEFSNG I-N
SUB inipal      ' ini PAL&(0:15) with DOS color palette

pal&(0) = rgb&(0, 0, 0)
pal&(1) = rgb&(0, 0, 63)
pal&(2) = rgb&(0, 65, 0)
pal&(3) = rgb&(0, 65, 63)
pal&(4) = rgb&(63, 0, 0)
pal&(5) = rgb&(63, 0, 63)
pal&(6) = rgb&(63, 31, 0)
pal&(7) = rgb&(63, 65, 63)
pal&(8) = rgb&(32, 32, 32)
pal&(9) = rgb&(32, 32, 100)
pal&(10) = rgb&(32, 97, 32)
pal&(11) = rgb&(31, 97, 100)
pal&(12) = rgb&(100, 31, 31)
pal&(13) = rgb&(100, 31, 100)
pal&(14) = rgb&(100, 97, 31)
pal&(15) = rgb&(100, 97, 100)

copypal
PALETTE USING pal&

LOCATE 28, 1: PRINT " palette similar to DOS-default loaded."

END SUB

SUB inipal1           ' GRAUSKALA - verlaufend linear

pal&(0) = rgb&(0, 0, 0)
pal&(15) = rgb&(100, 100, 100)

FOR i = 1 TO 14
x% = INT(i * 100 / 15 + .5)
pal&(i) = rgb&(x%, x%, x%)

NEXT i

copypal

PALETTE USING pal&

END SUB

DEFINT A-W
SUB inipals64 (shift)
n = 64
FOR i = 0 TO (n - 1)
j = (2 * n + i + shift) MOD n
IF shift < 0 THEN j = n - j - 1
x$ = CHR$(4 * i)
pals64(j) = x$ + x$ + x$
NEXT i

END SUB

DEFSNG A-H, O-W
SUB oldCode ' which is curretly not in use


''' mark cooord axis:
zx = 0                           ' ---axis
IF x = xa0 THEN zx = 1    '0
IF x = xa3 THEN zx = 1    '0   ' mark coordinates
IF x = xa1 THEN zx = 1    '1
IF x = xa2 THEN zx = 1    '2
IF x > xa4 OR x < xa5 THEN
  IF y = ya2 THEN zx = 1    '0
  IF y = ya1 THEN zx = 1    '0
END IF
IF y = ya0 THEN zx = 1    '1
IF y = ya3 THEN zx = 1    '1     ' ---axis
IF zx = 1 THEN z = -z   ' mark axis by inverting b/w




' IF ((x + y) MOD 2) = 0 THEN zx = -1      ' "mixed grey" for coord axis



''' mark coordinate axis:3
IF zsc = 1 / 2 THEN
zx = 1
IF ((x + y) MOD 2) = 0 THEN zx = -1
IF x = 249 THEN z = zx
IF x = 604 THEN z = zx         ' mark coordinates
IF x = 959 THEN z = zx    '0
IF x = 960 THEN z = zx    '0
IF y = 880 THEN z = zx
IF y = 481 THEN z = zx    '0
IF y = 480 THEN z = zx    '0
IF y = 81 THEN z = zx
END IF



' zcol = z MOD 16   ' most simple color assignment

                         '  M i s c h f a r b e n :

IF z = max THEN     ' ---
zcol = 0
ELSE                ' ---

'zcol = (max - z) MOD 32    ' 0..31
zcol = (max - z) MOD 30     ' 0..29  don't cycle or mix color 0

z2 = zcol MOD 2             ' 0/1
'zcol = INT(zcol / 2)       ' 0..15
zcol = 1 + INT(zcol / 2)    ' 1..15

IF z2 > 0 THEN             ' use "next" color for every other pixel:
zz = (x + y) MOD 2         '  zz = 0/1/0/1 abwechselnd
IF zz > 0 THEN zcol = (zcol + 1) MOD 16
END IF

END IF               ' ---

END SUB

DEFSNG I-N, X-Z
SUB openBMP4 (w%, h%)

IF w% MOD 4 > 0 OR h% MOD 4 > 0 THEN
BEEP: BEEP: BEEP
PRINT " odd BMP zize - not implemented !"
errmsg " illegal size for BMP"
END IF

f$ = d0$ + "FRACT.BMP"
OPEN f$ FOR OUTPUT AS #4

PRINT #4, "BM";
x3& = 3& * w% * h%
x& = x3& / 2 + 27

PRINT #4, byte4$(x&);

PRINT #4, byte4$(0); byte4$(54); byte4$(40);

x& = w%
PRINT #4, byte4$(x&);

x& = h%
PRINT #4, byte4$(x&);

PRINT #4, CHR$(1); CHR$(0);

PRINT #4, byte4$(24); CHR$(0); CHR$(0);

PRINT #4, byte4$(x3&);    '  ???

PRINT #4, CHR$(17); CHR$(23); CHR$(0); CHR$(0);    ' <<<<< ??
PRINT #4, CHR$(17); CHR$(23); CHR$(0); CHR$(0);    ' <<<<< ??

x& = 0&
PRINT #4, byte4$(0);
PRINT #4, byte4$(0);

END SUB

DEFINT I-N, X-Z
                            ' 16*3* 0..63
SUB readCOL (file$, ishift) ' read color palette from F3D's *.col file

f$ = file$

IF f$ = "" THEN          'ask for filename:
LOCATE 28, 1: PRINT "                           ";
LOCATE 28, 1: INPUT " COL-file="; f$
LOCATE 28, 1: PRINT "                           ";
LOCATE 28, 1: INPUT " ishift="; ishift
IF f$ = "" THEN GOTO endcol
END IF

f$ = capit$(f$)
IF RIGHT$(f$, 4) <> ".COL" THEN f$ = f$ + ".COL"

f$ = dir$ + f$
OPEN f$ FOR BINARY AS #3
DIM c AS STRING * 48
GET #3, 184, c            ' 16*3* 0..63
CLOSE 3

FOR i = 0 TO 15
k = i * 3 + 1
c1$ = MID$(c, k)
c2$ = MID$(c, k + 1)
c3$ = MID$(c, k + 2)

x& = ASC(c3$)
x& = x& * 256 + ASC(c2$)
x& = x& * 256 + ASC(c1$)

j = (i + ishift) MOD 16
pal&(j) = x&

NEXT i

copypal

PALETTE USING pal&

LOCATE 27, 1
PRINT "palette1 loaded from "; f$; " shifted "; ishift; "     ";
endcol:
END SUB

SUB readCOL2 (file$, ishift)

ll = 28
f$ = file$


IF f$ = "" THEN       ' ask for filename: ---
LOCATE ll, 1: PRINT "                           ";
LOCATE ll, 1: INPUT " COL-file="; f$
IF f$ = "" THEN GOTO endcol2
END IF    '---

f$ = capit$(f$)
IF RIGHT$(f$, 4) <> ".COL" THEN f$ = f$ + ".COL"


f$ = dir$ + f$
OPEN f$ FOR BINARY AS #3
DIM c AS STRING * 48
GET #3, 184, c              ' 16*3* 0..63
CLOSE 3


FOR i = 0 TO 15
k = i * 3 + 1
y$ = MID$(c, k, 1)
y1$ = CHR$(4 * ASC(y$))
y$ = MID$(c, k + 1, 1)
y2$ = CHR$(4 * ASC(y$))
y$ = MID$(c, k + 2, 1)
y3$ = CHR$(4 * ASC(y$))

j = (i + ishift) MOD 16
pals2(j) = y3$ + y2$ + y1$

NEXT i

LOCATE 28, 1
PRINT "palette2 loaded from "; f$; " shifted "; ishift; "     ";

endcol2:

END SUB

DEFINT A-H, O-W
SUB readmap16 (file$, shift%)
n = 16
k = 0   'k=0(0..63) 1(0..100)

f$ = file$
IF f$ = "" THEN
INPUT "file "; f$
IF f$ = "" GOTO endmap1
INPUT "shift= "; shift%
END IF

f$ = capit$(f$)
IF RIGHT$(f$, 4) <> ".MAP" THEN f$ = f$ + ".MAP"
PRINT
PRINT "loading palette1 from "; f$; " shifted "; shift%; "     ";


f$ = dir$ + f$
OPEN f$ FOR INPUT AS #5
LINE INPUT #5, l$
PRINT l$
IF INSTR(l$, "#100") > 0 THEN k = 1
FOR i = 0 TO n - 1
INPUT #5, r, g, b

IF k = 1 THEN GOSUB conv1
'PRINT i, r, g, b

p& = b
p& = 256 * p& + g
p& = 256 * p& + r

j = (32 + i + shift) MOD n
IF shift% < 0 THEN j = n - j - 1
pal&(j) = p&

NEXT i
CLOSE #5

copypal

PALETTE USING pal&

LOCATE 27, 1
PRINT "palette1 loaded from "; f$; " shifted "; shift%; "     ";
PRINT l$
GOTO endmap1

conv1:
conv63 r
conv63 g
conv63 b
RETURN
     
endmap1:
END SUB

SUB readMAP99 (file$, shift)   ' read n99 colors from *.MAP
                                ' supply pal&(0..15),..      and
                                '        pals99(0..n-1)

k = 0   'k=0(0..63) 1(0..100)    [2 (0..255)]


f$ = file$
IF f$ = "" THEN
INPUT "file "; f$
IF f$ = "" GOTO endmap99
INPUT "shift= "; shift%
END IF

f$ = capit$(f$)
IF RIGHT$(f$, 4) <> ".MAP" THEN f$ = f$ + ".MAP"

f$ = dir$ + f$

OPEN f$ FOR INPUT AS #5
LINE INPUT #5, l$        ' read header line
PRINT l$
IF INSTR(l$, "#100") > 0 THEN k = 1
INPUT #5, n99         ' read n99=number of colors
IF n99 < 16 OR n99 > 300 THEN errmsg "strange value for #of colors n99 !!!"

PRINT
PRINT "loading "; n99; " colors from "; f$; " shifted "; shift%; "     ";


FOR i = 0 TO n99 - 1       ' cycle for n99 colors/lines:
INPUT #5, r, g, b
'PRINT i, r, g, b

GOSUB conv98  ' x$ = RGBvalue

j = (2 * n99 + i + shift) MOD n99
IF shift < 0 THEN j = n99 - j - 1
j2 = INT(j * 16 / n99)
pals99(j) = x$

IF k = 1 THEN GOSUB conv99       ' convert  % (0..100)  -->  (0..63)
p& = b: p& = 256 * p& + g: p& = 256 * p& + r
pal&(j2) = p&


NEXT i
CLOSE #5

copypal

PALETTE USING pal&

LOCATE 27, 1
PRINT "palette1 loaded from "; f$; " shifted "; shift; "     ";
PRINT l$
GOTO endmap99

conv99:    ' r,g,b:  0..100 --> 0..63
conv63 r
conv63 g
conv63 b
RETURN

conv98:
IF k = 1 THEN
ir = INT(r * 255 / 100)
ig = INT(g * 255 / 100)
ib = INT(b * 255 / 100)
END IF
IF k = 0 THEN
ir = 4 * r
ig = 4 * g
ib = 4 * b
END IF
IF k = 2 THEN errmsg "not yet implemented k "
'x$ = CHR$(ir) + CHR$(ig) + CHR$(ib)
x$ = CHR$(ib) + CHR$(ig) + CHR$(ir)
RETURN

endmap99:
END SUB

DEFSNG A-H, J-W
SUB readPCXpal (file$, ishift)


f$ = file$
ll = 28     ' last line for input

IF f$ = "" THEN            ' ask for infile:
LOCATE ll, 1: PRINT "                           ";
LOCATE ll, 1: INPUT " PCX-file="; f$
IF f$ = "" THEN GOTO ende1
LOCATE ll, 1: PRINT "                           ";
LOCATE ll, 1: INPUT " ishift="; ishift
END IF

f$ = capit$(f$)
IF RIGHT$(f$, 4) <> ".PCX" THEN f$ = f$ + ".PCX"

f$ = dir$ + f$
OPEN f$ FOR BINARY AS #1

DIM c AS STRING * 48
GET #1, 17, c             ' 16*3* 0..255 ?!!
CLOSE 1

FOR i = 0 TO 15
k = i * 3 + 1
c1$ = MID$(c, k)
c2$ = MID$(c, k + 1)
c3$ = MID$(c, k + 2)

c1% = ASC(c1$) / 4
c2% = ASC(c2$) / 4
c3% = ASC(c3$) / 4

IF c1% > 63 THEN c1% = 63
IF c2% > 63 THEN c2% = 63
IF c3% > 63 THEN c3% = 63

x& = c3%
x& = x& * 256 + c2%
x& = x& * 256 + c1%

j = (i + ishift) MOD 16
pal&(j) = x&

NEXT i

copypal

PALETTE USING pal&
LOCATE 27, 1
PRINT "palette1 loaded from "; f$; " shifted "; ishift; "     ";

ende1:
END SUB

DEFINT J-N
SUB readPCXpal2 (file$, ishift)

f$ = file$
ll = 28     ' last line for input

IF f$ = "" THEN      ' ask for infile:
LOCATE ll, 1: PRINT "                           ";
LOCATE ll, 1: INPUT " PCX-file="; f$
IF f$ = "" THEN GOTO ende2
END IF

f$ = capit$(f$)
IF RIGHT$(f$, 4) <> ".PCX" THEN f$ = f$ + ".PCX"

f$ = dir$ + f$
OPEN f$ FOR BINARY AS #1

DIM c AS STRING * 48
GET #1, 17, c               ' 16*3* 0..255 ?!!
CLOSE 1

FOR i = 0 TO 15

k = i * 3 + 1
j = (ishift + i) MOD 16
pals2(j) = MID$(c, k, 3)

NEXT i

LOCATE 28, 1
PRINT "palette2 loaded from "; f$; " shifted "; ishift; "     ";

ende2:
END SUB

DEFSNG I-N
FUNCTION rgb& (r%, g%, b%)

'  input: red-green-blue values in % as integer
' output: long rgb&

r = INT(.01 * r% * 64)
g = INT(.01 * g% * 64)
b = INT(.01 * b% * 64)

IF r > 63 THEN r = 63
IF g > 63 THEN g = 63
IF b > 63 THEN b = 63

rgb& = r + 256 * (g + 256 * b)

END FUNCTION

SUB waitkb
BEEP
ll = 29
LOCATE ll, 1: PRINT " any key to continue ..        ";
lbl1:
k$ = INKEY$

IF k$ = "" GOTO lbl1
IF k$ = CHR$(27) THEN SYSTEM  ' exit on ESC

' otherwise continue:
LOCATE ll, 1: PRINT "                                         ";
END SUB

